/*
My Roomate Stole my Break CPX 2
  This CPX is in charge of the bulk of the events. It gets the notification that roomate1 took a break and proceeds to run
  the make.com scenario we set up for it. It then recieves the pinValue from Blynk to turn the tv on for roomate2. And then notifys 
  CPX 1 that roomate1's break is over.

  The circuit:
  * CPX board 
  * CPX Battery Pack

  Video link: https://clipchamp.com/watch/eim8M2YwC1u
  Created By:
  Student1_David Dushi #342851532
  Student2_Asaf Gomes de Mesquita #316516756
*/ 




/* Fill-in information from Blynk Device Info here */
#define BLYNK_TEMPLATE_ID           "YourBLYNK_TEMPLATE_ID"
#define BLYNK_TEMPLATE_NAME         "YourBLYNK_TEMPLATE_NAME "
#define BLYNK_AUTH_TOKEN            "YourBLYNK_AUTH_TOKEN"

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT SerialUSB

#include <Adafruit_CircuitPlayground.h>
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

#if !defined(ARDUINO_SAMD_CIRCUITPLAYGROUND_EXPRESS)
  #error "Infrared support is only for the Circuit Playground Express, it doesn't work with the Classic version"
#endif

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "Wifi_Username";
char pass[] = "Wifi_Password";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

#define MY_PROTOCOL NEC
#define MY_BITS 32
#define ONE 0x20DF8877
#define POWER 0x20DF10EF

ESP8266 wifi(&EspSerial);

// This function will be called every time Slider Widget
// in Blynk app writes values to the Virtual Pin V1
BLYNK_WRITE(V0)
{
  int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
  Serial.println(pinValue); // show that pin has been changed i.e. webhook worked 
  if(pinValue == 1){
    CircuitPlayground.setPixelColor(0,128,0,0); // set led to red 
    CircuitPlayground.irSend.send(MY_PROTOCOL,POWER ,MY_BITS); // send IR with power button 
    CircuitPlayground.setPixelColor(0,0,0,0); // turn off led 
  }
  
}

void setup()
{
  CircuitPlayground.begin();
  // Debug console
  SerialUSB.begin(115200);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass);
 
}

void loop()
{
  Blynk.run();
}
